{F+}
(* ------------------------------------------------------------------ *)
(* Test case for System.Concat (Usage exampe for TPUnit).             *)
(* Version: 1.10                                                      *)
(* Author: Peter Kofler, www.code-cop.org                             *)
(* System: Turbo Pascal 6.01                                          *)
(* ------------------------------------------------------------------ *)
PROGRAM Concat_T;

USES TPUnit;

TYPE ConcatTest = OBJECT(TestCase)
        PROCEDURE SetUp; VIRTUAL;
        PROCEDURE TearDown; VIRTUAL;
        PROCEDURE TestEmpty;
        PROCEDURE TestFails;
        PROCEDURE TestTwo;
        PROCEDURE Run; VIRTUAL;
     END;

PROCEDURE ConcatTest.SetUp;
BEGIN
   Write(' SetUp');
END;

PROCEDURE ConcatTest.TearDown;
BEGIN
   Write(' TearDown');
END;

PROCEDURE ConcatTest.TestEmpty;
BEGIN
   Write(' Empty');
   AssertEqualsStr('empty concat', '', Concat('', ''));
END;

PROCEDURE ConcatTest.TestFails;
BEGIN
   Write(' Fails');
   AssertEqualsStr('must fail', 'a', Concat('a', 'b'));
END;

PROCEDURE ConcatTest.TestTwo;
BEGIN
   Write(' Two');
   AssertEqualsStr('two', 'ab', Concat('a', 'b'));
END;

PROCEDURE ConcatTest.Run;
BEGIN
   RunTest('TestEmpty', @ConcatTest.TestEmpty);
   RunTest('TestTwo', @ConcatTest.TestTwo);
   RunTest('TestFails', @ConcatTest.TestFails);
END;

CONST testee:ConcatTest = ();
BEGIN
   testee.Run
END.
