PROGRAM Lists_T;

USES TPUnit, Lists;

TYPE ArrayListTest = OBJECT(TestCase)
        _act:ArrayListPtr;
        PROCEDURE SetUp; VIRTUAL;
        PROCEDURE TearDown; VIRTUAL;
        PROCEDURE TestEmpty;
        PROCEDURE TestAdd;
        PROCEDURE TestPut;
        PROCEDURE Run; VIRTUAL;
     END;

PROCEDURE ArrayListTest.SetUp;
BEGIN
   _act := new(ArrayListPtr, Init);
END;

PROCEDURE ArrayListTest.TearDown;
BEGIN
   IF _act <> NIL THEN dispose(_act, Destroy);
END;

PROCEDURE ArrayListTest.TestEmpty;
BEGIN
   AssertTrue('isEmpty', _act^.IsEmpty);
   AssertEquals('size', 0, _act^.Size);
END;

PROCEDURE ArrayListTest.TestAdd;
BEGIN
   _act^.Add(3);
   AssertFalse('isEmpty', _act^.IsEmpty);
   AssertEquals('size', 1, _act^.Size);

   _act^.Add(5);
   AssertEquals('size', 2, _act^.Size);

   AssertEquals('get 0', 3, _act^.Get(0));
   AssertEquals('get 1', 5, _act^.Get(1));
END;

PROCEDURE ArrayListTest.TestPut;
BEGIN
   _act^.put(0,3);
   AssertEquals('size', 1, _act^.Size);
   AssertEquals('get 0', 3, _act^.Get(0));

   _act^.put(9,9);
   AssertEquals('size', 10, _act^.Size);
   AssertEquals('get 0', 3, _act^.Get(0));
   AssertEquals('get 3', 0, _act^.Get(3));
   AssertEquals('get 9', 9, _act^.Get(9));

   _act^.put(19,19);
   AssertEquals('size', 20, _act^.Size);
   AssertEquals('get 0', 3, _act^.Get(0));
   AssertEquals('get 9', 9, _act^.Get(9));
   AssertEquals('get 19', 19, _act^.Get(19));
END;

PROCEDURE ArrayListTest.Run;
BEGIN
   RunTest('TestEmpty', @ArrayListTest.TestEmpty);
   RunTest('TestAdd', @ArrayListTest.TestAdd);
   RunTest('TestPut', @ArrayListTest.TestPut);
END;

CONST testee:ArrayListTest = ();
BEGIN
   testee.Run
END.
